#include "Python.h"
#include "test_module.h"

static PyObject *
testModule_simple(PyObject *self, PyObject *args)
{
    // Ensure a library is properly linked when the path contains spaces
    assert(_return_1() == 1);
    
    // Ensure macros get properly defined
    assert(strcmp(MODULE_VERSION, "1.0.5") == 0);
    assert(strcmp(SPACE_STRING, "with space") == 0);
    assert(strcmp(SPECIAL_CHARS, "&*<>|()^") == 0);
    
    return Py_BuildValue("s", "Success!");
}

static PyMethodDef TestModuleMethods[] = {
    {"simple", testModule_simple, METH_VARARGS, "Simple print test."},
    {NULL, NULL, 0, NULL}
};

static struct PyModuleDef testmodule = {
    PyModuleDef_HEAD_INIT,
    "testModule",
    NULL,
    -1,
    TestModuleMethods
};

PyMODINIT_FUNC
PyInit_testModule(void)
{
    return PyModule_Create(&testmodule);
}

